

/* Copyright 2003 Uli Funcke & Klaus Kurzmann, FluxNetz GmbH */

/*
 * This file is part of Tanne
 *
 * Tanne is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * Tanne is distributed in the hope that it will be usefull,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tanne; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */



#include "defines.h"





void client(int socke, short neusessid)
{
	long f;

	sess_id = -1;									// noch nicht vergeben
	close(Gsocke);
	Gsocke = socke;								// im Child wird UR-GSocke nicht mehr gebraucht
#ifndef EIN_BYTE_LESEN
	anz_gelesen[0] = anz_gelesen[1] = 0;
	lesezeiger[0] = lesezeiger[1] = 0;
#endif

#ifdef DEBUG3
	logger("---CHILD GESTARTET---");
#endif
	client_signale();							// Signale "Child" setzen
	if (!shmAn())
		ende(ZOMBIE);

	socken_init(Gsocke);					// TCP_NODELAY setzen

	lesen(Gsocke);								// Zeile lesen aus socket


	if (zeile[0] == '@')					// login-Befehl
	{
#ifdef  DEBUG
		logger("login: %s", zeile);
#endif
		if ((f = strlen(zeile)) >= (signed)(MAX_ORDNER - strlen(BEFEHLE_ORDNER) - 2))
		{
			logger("FATAL: login command to long: %d Bytes", f);
			senden(F_FEHLER, Gsocke);
			P();
			Zombie(neusessid);
			V();
			ende(ZOMBIE);
		}

		sess_id = neusessid;
		P();
#ifdef USE_SOCKETPAIR
		GHand = Session[sess_id].hand[0];
#else
		GHandL = Session[sess_id].hl[0];
		GHandS = Session[sess_id].hs[1];
#endif
		V();
#ifdef DEBUG2
#ifdef USE_SOCKETPAIR
		logger("login with sess_id = %d (GHand=%d, Socket=%d)", sess_id, GHand, Gsocke);
#else
		logger("login with sess_id = %d (GHandL=%d, GHandS=%d, Socket=%d)", sess_id, GHandL, GHandS, Gsocke);
#endif
#endif
		AufrufTriggern();
		while ((f = SessionStatus(sess_id)) != STANDBY)
		{
			if (f != AUFRUF_TRIGGER)	// Aufruf_triggern mu in STANDBY enden, sonst Fehler
			{
				logger("FATAL: ID is from a already closed Session");
				senden(F_FEHLER, Gsocke);
				ende(ZOMBIE);
			}
			warten(200);
		}

		Reden();										// GHand redet mit Gsocke
	}
	else													// normaler Befehl
	{
		P();
		Zombie(neusessid);
		V();
		if ((f = SucheID(zeile)) != -1)	// zeile enthlt TID
		{
			P();
			strcpy(zeile, Befehl[f].bef);	// Aufruf in zeile Kopieren
			sess_id = Befehl[f].sess_id;
#ifdef USE_SOCKETPAIR
			GHand = Session[sess_id].hand[0];
#else
			GHandL = Session[sess_id].hl[0];
			GHandS = Session[sess_id].hs[1];
#endif
			Session[sess_id].ablauf = Session[sess_id].timeout;	// geht von vorne los
			if ((Befehl[f].flag & BF_MULTI) == 0)
				BefehleWeg(sess_id);		// gefundene Session ist auf jeden Fall zuende
			V();
			while ((f = SessionStatus(sess_id)) != STANDBY)
			{
				if (f != AKTIV)
				{
					logger("FATAL: ID is from a already closed Session");
					ende(ZOMBIE);
				}
				warten(200);
			}
#ifdef USE_SOCKETPAIR
			senden(zeile, GHand);
#else
			senden(zeile, GHandS);
#endif
			Reden();									// die normale Kommunikation
		}
		else
		{
			zeile[15] = '.';
			zeile[16] = '.';
			zeile[17] = '.';
			zeile[18] = 0;						// Damit die Syslog nicht zu lang wird und die ganze ID interessiert sowieso nicht
			logger("FATAL: ID (%s) not found", zeile);
			senden(F_FEHLER, Gsocke);	// ID-Nicht gefunden (Programmierfehler in PHP oder Einbruchversuch)
		}
	}

#ifdef DEBUG2
	logger("Kind-Funktion ist durch!");
#endif
	ende(ZOMBIE);
}












/* die Zentrale: */


void Reden(void)
{
	long turbo1, turbo2, l;
	short anzf_p2s, anzf_s2p, sel;

	while (SessionStatus(sess_id) != STANDBY)
		warten(100);
	P();
	Session[sess_id].a_pid = getpid();
	Session[sess_id].status = AKTIV;
	V();
#ifdef DEBUG3
	logger("Reden() sess_id = %d", sess_id);
#endif
	turbo1 = turbo2 = 0;					// Turbo Modus wird durch '|=[AnzBytes]\n' eingeleitet
	anzf_p2s = anzf_s2p = 0;
	do
	{
		sel = der_select_test();
//___________________________________________________________________________________________________________
		if (sel & SELECT_P2S)				// vom Programm zum Socket
		{
#ifdef DEBUG2
			logger("Daten vom Programm zum Socket");
#endif
			if (turbo1)
			{
#ifdef USE_SOCKETPAIR
				l = bytes_lesen(GHand, turbo1);
#else
				l = bytes_lesen(GHandL, turbo1);
#endif
				if (l)
				{
					anzf_p2s = 0;
					turbo1 -= l;
					if (turbo1 < 0)
					{
						turbo1 = 0;
#ifdef DEBUG2
						logger("Turbo >> fertig");
#endif
					}
					bytes_senden(l, Gsocke);
				}
				else
					anzf_p2s++;
			}
			else											// kein turbo
			{
#ifdef USE_SOCKETPAIR
				if (lesen(GHand))
#else
				if (lesen(GHandL))
#endif
				{
					if (zeile[0] == SPZ)
					{
						switch (zeile[1])
						{
							case SPZ:
								logger("------------ session %d normally closed -----------", sess_id);
								ende(ZOMBIE);

							case SPZ_CLIENDE:
#ifdef DEBUG
								logger("Seite ordentlich beendet");
#endif
								ende(STANDBY);

							case SPZ_TURBO1:
								turbo1 = atol(zeile + 2);
#ifdef DEBUG
								logger("Turbo > %d Bytes", turbo1);
#endif
								break;

							case SPZ_TURBO2:
								turbo2 = atol(zeile + 2);
#ifdef DEBUG
								logger("Turbo < %d Bytes", turbo2);
#endif
								break;

							case SPZ_TIMEOUT:
								l = atol(zeile + 2);
								if (l >= SESSION_TIME_MIN && l <= SESSION_TIME_MAX)
								{
									P();
									Session[sess_id].timeout = l;
									V();
									logger("Timeout set to %d min (sess_id = %d)", l / 2, sess_id);
								}
								else
									logger("Timeout %d min illegal value", l / 2);
								break;

							case SPZ_AGAIN:
								if (!BefehlEinfuegen(BF_MULTI, 2))
								{
									zeile[0] = '\n';	// Leere Zeile, da keine ID mehr frei
									zeile[1] = 0;
								}
								senden(zeile, Gsocke);
								break;

							default:
								if (!BefehlEinfuegen(0, 1))
								{
									zeile[0] = '\n';	// Leere Zeile, da keine ID mehr frei
									zeile[1] = 0;
								}
								senden(zeile, Gsocke);
								break;
						}
					}
					else
						senden(zeile, Gsocke);
				}
				else										// lesen() returned 0
					anzf_p2s++;
			}
		}

//___________________________________________________________________________________________________________
		if (sel & SELECT_S2P)				// vom Socket zum Programm
		{
#ifdef DEBUG2
			logger("Daten vom Socket zum Programm");
#endif
			if (turbo2)
			{
				l = bytes_lesen(Gsocke, turbo2);
				if (l)
				{
					anzf_s2p = 0;
					turbo2 -= l;
					if (turbo2 < 0)
					{
#ifdef DEBUG2
						logger("Turbo << fertig");
#endif
						turbo2 = 0;
					}
#ifdef USE_SOCKETPAIR
					bytes_senden(l, GHand);
#else
					bytes_senden(l, GHandS);
#endif
				}
				else
					anzf_s2p++;
			}
			else											// kein turbo
			{
				if (lesen(Gsocke))
				{
					anzf_s2p = 0;
#ifdef USE_SOCKETPAIR
					senden(zeile, GHand);
#else
					senden(zeile, GHandS);
#endif
				}
				else
					anzf_s2p++;
			}
		}
//___________________________________________________________________________________________________________
		if (!sel)
		{
#ifdef DEBUG2
			logger("select() ohne result");
#endif
			if (++anzf_s2p >= 4)
			{
				logger("FATAL: select() failed (sess_id = %d)", sess_id);
				logger("Sys_errlist: %s", sys_errlist[errno]);
				ende(STANDBY);
			}
			warten(anzf_s2p * 100);
		}
//___________________________________________________________________________________________________________
		if (anzf_s2p >= 2)
		{
#ifdef DEBUG
			logger("Null Bytes aus Frontend gelesen");
#endif
			ende(STANDBY);
		}
		if (anzf_p2s >= 2)
		{
#ifdef DEBUG
			logger("Null Bytes aus Backend gelesen");
#endif
			ende(ZOMBIE);
		}
	}
	while (JA);
}
