<?php

	$timestamp = gmdate( 'U' );
	$Expires = sprintf( "%s %02d %s %04d %02d%02d%02d GMT",
		gmdate( "D", $timestamp ), gmdate( "d", $timestamp ),
		gmdate( "M", $timestamp ), gmdate( "Y", $timestamp ),
		gmdate( "H", $timestamp ), gmdate( "i", $timestamp ),
		gmdate( "s", $timestamp ) );

	$LastModified = sprintf( "%s %02d %s %04d %02d%02d%02d GMT",
		gmdate( "D" ), gmdate( "d" ), gmdate( "M" ), gmdate( "Y" ),
		gmdate( "H" ), gmdate( "i" ), gmdate( "s" ) );
	
	logger( "SCRIPT_NAME=$SCRIPT_NAME" );

//________________________________________________________________________________________________________

	header( "Expires: $Expires" );
	header( "Last-Modified: $LastModified" );
	header( "Cache-Control: no-cache, must-revalidate" );
	header( "Pragma: no-cache" );

//________________________________________________________________________________________________________

	define( "TANNE_PORT", 14002 );

	$GTanneHand = -1;


//________________________________________________________________________________________________________
// Functions


function logger( $txt )
{
	openlog( "BOOKMARK", LOG_PID, LOG_DAEMON );
	syslog( LOG_INFO, $txt );
	closelog();
}






function tanne_senden( $txt )
{
	global $GTanneHand;
	
	if( $GTanneHand != -1 )
	{
		if( !( fwrite( $GTanneHand, "$txt\n" ) ) )
			logger( "Fehler bei schreiben von $txt" );
		flush();
		logger( "sende '$txt'" );
	}
}




function tanne_lesen()
{
	global $GTanneHand;

	$ret = "";
	$z = "";
	if( $GTanneHand != -1 )
	{
		while( ( $z = fread( $GTanneHand, 1 ) ) != "\n" )
			$ret .= $z;
		logger( "lese '$ret'" );
	}
	return( $ret );
}





function tanne_auf()
{
	global $GTanneHand;
	
	$GTanneHand = fsockopen( "localhost", TANNE_PORT, &$errno, &$errstr, 30 );
	if( !$GTanneHand )
	{
		logger( "$errno: $errstr" );
		$GTanneHand = -1;
		return( FALSE );
	}
	logger( "Tanne auf" );
	return( TRUE );
}



function tanne_zu()
{
	global $GTanneHand;
	if( $GTanneHand == -1 )
		return FALSE;
	else
	{
		fclose( $GTanneHand );
		$GTanneHand = -1;
		return TRUE;
	}
}




function html_link( $url, $txt, $target="" )
{
	$html = "<a href=\"$url\"";
	if( $target != "" )
		$html .= " target=\"$target\"";
	$html .= ">$txt</a>";
	return( $html );
}



function get_tid( $bef )
{
	tanne_senden( "bef:$bef" );
	return( tanne_lesen());
}




function get_linkinfo()
{
	tanne_senden( "lnk" );
	return( tanne_lesen());
}



function get_user()
{
	tanne_senden( "usr" );
	return( tanne_lesen());
}




function tanne_link( $s="" )
{
	global $SERVER_NAME;
	global $SCRIPT_NAME;

	$u = "http://" . $SERVER_NAME . $SCRIPT_NAME;
	
	if( substr( $s, 0, 1 ) == "|" )
		$u .= "?TID=" . substr( $s, 1 );
	return( $u );
}



function html_form_text( $name )
{
	return( "<input type=\"text\" name=\"$name\">\n" );
}


function html_form_pw( $name )
{
	return( "<input type=\"password\" name=\"$name\">\n" );
}


function html_form_submit( $val, $name="" )
{
	$html = "<input type=\"submit\" ";
	if( $name > "" )
		$html .= "name=\"$name\" ";
	$html .= "value=\"$val\">\n";
	return( $html );
}


//________________________________________________________________________________________________________
// Start

	if( $TID > "" ) // Tanne - command
	{
		// Connetcting to Tanne
		logger( "TID='$TID'" );
		tanne_auf();
		if( $TID == "start" )
		{
			tanne_senden( "@bookmark/backend.php" ); // starting sequence
			if( tanne_lesen() != "bookmark ok" )
			{
				logger( "Error: from Tanne = '$k'" );
				tanne_zu();
				$body = "<h1>Tanne nicht gestartet</h1>\n";
			}
			else
				tanne_senden( "login" ); // first command
		}
		else
			tanne_senden( $TID ); // send command to Tanne

		if( tanne_lesen() != "OK" )
		{
			logger( "Error: from Tanne = '$k'" );
			tanne_zu();
			$body = "<h1>Tanne nicht gestartet</h1>\n";
		}

		while( list( $k, $v ) = each( $HTTP_POST_VARS ))
		{
			$l = strlen( $v );
			tanne_senden( "$k=$l" );
			if( $GTanneHand != -1 && $l > 0 )
				fwrite( $GTanneHand, $v );
			tanne_senden( "" ); // end-marker
		}		
		tanne_senden( "OK" );
		$seite = tanne_lesen();
	}
	else // no TID -> startpage
		$seite = "login";

	switch( $seite )
	{
		default: // login
			$body = "<div class=\"anfang\">\n";
			$body .= "<form action=\"" . tanne_link( "|start" ) . "\" method=\"post\">\n";
			$body .= "<p class=\"info\">Name</p>\n";
			$body .= "<p class=\"inhalt\">" . html_form_text( "user" ) . "</p>\n";
			$body .= "<p class=\"info\">Passwort</p>\n";
			$body .= "<p class=\"inhalt\">" . html_form_pw( "pw" ) . "</p>\n";
			$body .= "<p class=\"knopf\">" . html_form_submit( "Los" ) . "</p>\n";
			$body .= "</form>\n";
			$body .= "</div>\n";
			break;

		case 'liste':
			$body = "<h1>Bookmarks von " . get_user() . "</h1>\n";
			$body .= "<table>\n";
			for( ;( $id = get_linkinfo()) != ""; $body .= $bz )
			{
				$s = tanne_lesen();
				$bz = '<tr><td>' . html_link( $s, $s, "_blank" ) . "</td><td>" . html_link( tanne_link( get_tid( "weg " . $id )), "[weg]" ) . '</td></tr>';
			}
			
			$body .= "</table>\n";
			$body .= "<form action=\"" . tanne_link( get_tid( "neu" )) . "\" method=\"post\">\n";
			$body .= "<p>" . html_form_text( "neulink" ) . "</p>\n";
			$body .= "<p>" . html_form_submit( "Neu" ) . "</p>\n";
			$body .= "</form>\n";
			$body .= '<p>' . html_link( tanne_link( get_tid( "logout" )), "Ende" ) . '</p>';
			break;
	}
	
	tanne_senden( "ende" );	
	tanne_zu();
	
	//__________________________________________________________________________________________________________
	// HTML-Start

	print( "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/1999/REC-html401-19991224/loose.dtd\">\n" );
	print("<html>\n<head>\n");
	print( "<title>Bookmarks</title>\n" );
	print( '<meta http-equiv="content-type" content="text/html; charset=iso-8859-1">' . "\n" );
	print( '<meta http-equiv="content-style-type" content="text/css">' . "\n" );
	print( "<style type=\"text/css\" media=\"screen\">\n" );
	print( "<!--\n" );
	print( "@import \"http://" . $SERVER_NAME . "/bookmark.css\";\n" );
	print( "-->\n" );
	print( "</style>\n" );
	print( "</head>\n" );
	print( "<body>\n" );
	print( $body );
	print( "</body>\n" );
	print( "</html>\n" );

?>


