
/* Copyright 2003 Uli Funcke & Klaus Kurzmann, FluxNetz GmbH */

/*
 * This file is part of Tanne
 *
 * Tanne is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * Tanne is distributed in the hope that it will be usefull,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tanne; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "defines.h"



SBefehl *Befehl;
SSession *Session;

int shm_id;
int sem_id;
int Gsocke;

#ifdef USE_SOCKETPAIR
int GHand;
#else
int GHandL;
int GHandS;
#endif
signed short sess_id;
struct sockaddr_in in_name;
char zeile[MAX_ZEILE];

#ifndef EIN_BYTE_LESEN
char lesebereich[2][MAX_LESEBEREICH];
short lesezeiger[2];
short anz_gelesen[2];
#endif
sigset_t signale, sig_alt;
struct sigaction sigh_term;
struct sigaction sigh_child;
struct sigaction sigh_alarm;
struct sigaction sigh_pipe;
long alt_freispeicher;
short sem_in_signal_flag;











int main(void)
{
	long sid, pid;
	int neuc;
	unsigned int s;

	sem_in_signal_flag = NEIN;
	Befehl = 0;
	Session = 0;
	alt_freispeicher = 0;

	logger("Version %s started", VERSION);

	if (setgid(2) != 0)						// daemon
	{
		logger("setgid(2) failed");
#ifndef DEBUG
		printf("konnte nicht unter daemon-gid starten, beendet\n");
		return (0);
#endif
	}

	close(STDIN_FILENO);
	close(STDOUT_FILENO);
	close(STDERR_FILENO);
	umask(NORMALE_UMASK);

	if (fork())										// Dmon werden
		return (0);

	setsid();
	setpgrp();

	if (!shmStart())
	{
		logger("FATAL: out of memory");
		return (1);
	}

	server_signale();
	if (!netz_init())
	{
		logger("FATAL: network initialisation failed");
		shmEnde();
		return (1);
	}

//_______________________________________________________________________________
// Serverschleife

	logger("server started, waiting for connections");
	while (JA)
	{
		s = sizeof(in_name);
		if ((neuc = accept(Gsocke, (struct sockaddr *) &in_name, &s)) > 0)
		{
			if (neuc <= 0)
			{
				logger("accept() failed");
			}
			else
			{
				if ((sid = NeueSession()) == -1)
				{
					logger("FATAL: System is full");
					senden(F_FEHLER, neuc);
					close(neuc);
				}
				else
				{
					pid = fork();
					switch (pid)
					{
						case 0:
							client(neuc, sid);
							exit(1);					// Kommt nie zurck
						case -1:
							logger("FATAL: fork() failed");
							senden(F_FEHLER, neuc);
							close(neuc);
							break;
						default:						// Papa macht weiter
							close(neuc);
#ifdef DEBUG
							logger("Connect auf Socket und Prozess mit PID=%d gestartet", pid);
#endif
							break;
					}
				}
			}
		}
	}
	return (0);										// passiert nie!
}









short NeueSession(void)
{
	long f;
	long h1, h2;

#ifndef USE_SOCKETPAIR
	long h3, h4;
#endif

	if (!shmAn())
	{
		logger("FATAL: shmAn() failed");
		return (-1);
	}
	P();
	for (f = 0; f < ANZ_SESSIONS; f++)
	{
		if (Session[f].status == FREI)
		{
			Session[f].status = BELEGT;
			Session[f].pid = -1;
			Session[f].a_pid = -1;
#ifdef USE_SOCKETPAIR
			if (socketpair(AF_UNIX, SOCK_STREAM, 0, Session[f].hand) != 0)
			{
				Session[f].status = FREI;
				logger("FATAL: socketpair() failed");
				V();
				shmAus();
				return (-1);
			}
			h1 = Session[f].hand[0];
			h2 = Session[f].hand[1];
#else
			if (pipe(Session[f].hl) != 0)
			{
				Session[f].status = FREI;
				logger("FATAL: pipe() failed");
				V();
				shmAus();
				return (-1);
			}
			if (pipe(Session[f].hs) != 0)
			{
				close(Session[f].hl[0]);
				close(Session[f].hl[1]);
				Session[f].status = FREI;
				logger("FATAL: pipe() failed");
				V();
				shmAus();
				return (-1);
			}
			h1 = Session[f].hl[0];
			h2 = Session[f].hl[1];
			h3 = Session[f].hs[0];
			h4 = Session[f].hs[1];
#endif
			Session[f].timeout = SESSION_TIME;	// als default
			Session[f].ablauf = SESSION_TIME;
			V();
			Statusbericht();
			shmAus();
#ifdef DEBUG
#ifdef USE_SOCKETPAIR
			logger("new session (id=%d) socketpair(%d,%d)", f, h1, h2);
#else
			logger("new session (id=%d) L-pipe(%d,%d), S-pipe(%d,%d)", f, h1, h2, h3, h4);
#endif
#endif
			return (f);								// ging, Session gefunden
		}
	}
	V();
	Statusbericht();
	shmAus();
	logger("FATAL: system is full. No more sessions at the moment.");
	return (-1);
}









// in zeile steht sowas wie @verz/command
// 1. Testen, ob rechte von verz ok,
// 2. Testen, ob Rechte von command ok,
// 3. fork()
// 4. Aufruf von Command

short AufrufStarten(signed short sess_ID)
{
	long aid, bid, p_in, n, f;

#ifndef USE_SOCKETPAIR
	long p_out;
#endif
	char aufruf[MAX_ORDNER];

	logger("--------------- session %d start ----- '%s' ---------------", sess_ID, zeile);
	if (punktpunkt_test(zeile + 1))
	{
		logger("FATAL: Invalid login-call: '%s'", zeile + 1);
		return (NEIN);
	}

	snprintf(aufruf, MAX_ORDNER - 1, "%s/%s", BEFEHLE_ORDNER, zeile + 1);

	for (f = strlen(aufruf) - 1; f >= 0; f--)
	{
		if (aufruf[f] == '/')				// den ersten von Rechts
		{
			aufruf[f] = 0;
			break;										// aus for
		}
	}

	if (f < 0)
	{
		logger("FATAL: invalid call '%s'", aufruf);
		return (NEIN);
	}


	aid = rechte_test(aufruf, JA);
	if (aid == 0)
	{
		logger("FATAL: permissions of '%s' are wrong", aufruf);
		return (NEIN);
	}

	aufruf[f] = '/';							// wieder dazufgen
	bid = rechte_test(aufruf, NEIN);
	if (bid == 0)
	{
		logger("FATAL: permissions of '%s' are wrong", aufruf);
		return (NEIN);
	}

	if (aid != bid)
	{
		logger("FATAL: '%s' owner of call and directory are not the same '%s'", zeile + 1);
		return (NEIN);
	}

	if (aid != TANNE_USER_ID && aid < MIN_UID)
	{
		logger("FATAL: '%s' UID=%d is not allowed (to small)", zeile + 1, aid);
		return (NEIN);
	}

	P();
#ifdef USE_SOCKETPAIR
	p_in = Session[sess_ID].hand[1];
#else
	p_in = Session[sess_ID].hs[0];
	p_out = Session[sess_ID].hl[1];
#endif
	V();


// ---------------------------fork()---------------------------------


#ifdef DEBUG
#ifdef USE_SOCKETPAIR
	logger("starte '%s' gegenhand=%d", aufruf, p_in);
#else
	logger("starte '%s' in=%d, out=%d", aufruf, p_in, p_out);
#endif
#endif
	if ((n = fork()) == 0)
	{
		if (dup2(p_in, STDIN_FILENO) == -1)
		{
			logger("FATAL: dup2 from %d to stdin failed", p_in);
			logger("Sys_errlist %d: %s", errno, sys_errlist[errno]);
			exit(127);
		}

#ifdef USE_SOCKETPAIR
		if (dup2(p_in, STDOUT_FILENO) == -1)
		{
			logger("FATAL: dup2 from %d to stdout failed", p_in);
			logger("Sys_errlist: %s", sys_errlist[errno]);
			exit(127);
		}
#else
		if (dup2(p_out, STDOUT_FILENO) == -1)
		{
			logger("FATAL: dup2 from %d to stdout failed", p_out);
			logger("Sys_errlist: %s", sys_errlist[errno]);
			exit(127);
		}
#endif

#ifdef USE_SOCKETPAIR
		if (dup2(p_in, STDERR_FILENO) == -1)
		{
			logger("FATAL: dup2 from %d to stderr failed", p_in);
			exit(127);
		}
#else
		if (dup2(p_out, STDERR_FILENO) == -1)
		{
			logger("FATAL: dup2 from %d to stderr failed", p_out);
			exit(127);
		}
#endif

		if (aid != TANNE_USER_ID)		// TANNE_USER_ID - Programme laufen mit root-Rechten
		{
			if (setgid(KUNDEN_GID) != 0)
				logger("setgid(%d) failed", KUNDEN_GID);
			if (setuid(aid) != 0)
			{
				logger("setuid(%d) failed", aid);
				logger("Sys_errlist: %s", sys_errlist[errno]);
				exit(111);
			}
		}

//    io_bereitung( STDIN_FILENO );
//    io_bereitung( STDOUT_FILENO );
//    io_bereitung( STDERR_FILENO );

		for (n = STDERR_FILENO + 1; n < 256; n++)
			close(n);									// Alles andere zu
#ifdef DEBUG
		logger("execl(%s)", aufruf);
#endif
		execl(aufruf, aufruf, NEIN);
		logger("FATAL: execl '%s' failed", aufruf);
		close(STDIN_FILENO);
		close(STDOUT_FILENO);
		close(STDERR_FILENO);
		exit(113);
	}

//-------------------------------------------------------------------------------

	if (n < 0)										// fork() ging nicht
	{
		logger("FATAL: fork() failed");
		return (NEIN);
	}

	P();
	Session[sess_ID].pid = n;
	V();
#ifdef DEBUG2
	logger("Prozess mit PID=%d gestartet", n);
#endif
	warten(50);
	P();
	Session[sess_ID].status = STANDBY;
	V();
#ifdef DEBUG2
	logger("AufrufStarten() ist durch");
#endif
	return (JA);									// alles OK!
}

