
/* Copyright 2003 Uli Funcke & Klaus Kurzmann, FluxNetz GmbH */

/*
 * This file is part of Tanne
 *
 * Tanne is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as published by
 * the Free Software Foundation.
 *
 * Tanne is distributed in the hope that it will be usefull,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tanne; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "defines.h"





// 0 = Fehler im select()
// SELECT_P2S = es sind Daten an GHand oder GHandL
// SELECT_S2P = es sind Daten an Gsocke
short der_select_test(void)
{
	long maxi;
	short ret;
	fd_set plex;

	ret = NEIN;
	if (lesezeiger[0] != anz_gelesen[0])	// Daten an Gsocke
		ret |= SELECT_S2P;
	if (lesezeiger[1] != anz_gelesen[1])	// Daten an GHand(L)
		ret |= SELECT_P2S;
	if (!ret)
	{
#ifdef USE_SOCKETPAIR
		maxi = GHand > Gsocke ? GHand + 1 : Gsocke + 1;
#else
		maxi = GHandL > Gsocke ? GHandL + 1 : Gsocke + 1;
#endif
		FD_ZERO(&plex);
#ifdef USE_SOCKETPAIR
		FD_SET(GHand, &plex);
#else
		FD_SET(GHandL, &plex);
#endif
		FD_SET(Gsocke, &plex);
		if (select(maxi, &plex, NEIN, NEIN, NEIN) > 0)
		{
#ifdef USE_SOCKETPAIR
			if (FD_ISSET(GHand, &plex))	// vom Programm zum Socket
#else
			if (FD_ISSET(GHandL, &plex))	// vom Programm zum Socket
#endif
				ret |= SELECT_P2S;

			if (FD_ISSET(Gsocke, &plex))	// vom Socket zum Programm
				ret |= SELECT_S2P;
		}
	}

	return (ret);
}










short punktpunkt_test(char *s)
{
	short p, f;

#ifdef  DEBUG3
	logger("punktpunkt_test(%s)", s);
#endif
	if (s[0] == '/')
		return (JA);								// Absolute Pfadangabe auch verboten

	for (f = 0, p = 0; s[f]; f++)
	{
		if (s[f] == '.')
		{
			p++;
			if (p == 2)
				return (JA);
		}
		else
			p = 0;
	}

#ifdef  DEBUG3
	logger("punktpunkt_test() durch");
#endif
	return (NEIN);
}







long rechte_test(char *q, short dir)
{
	struct stat s;

#ifdef  DEBUG3
	logger("rechte_test(%s)", q);
#endif
	if (stat(q, &s) != 0)
		return (0);									// Ging nicht
	if (dir)
	{
		if (!S_ISDIR(s.st_mode))		// mu ein Directory sein
			return (0);
	}
	else
	{
		if (!S_ISREG(s.st_mode))		// normale Datei, kein Link, kein Ordner
			return (0);
	}
	if (s.st_mode & S_IWOTH)			// keine Schreibrechte fr andere erlaubt
		return (0);
	// OK, Test bestanden
#ifdef  DEBUG3
	logger("rechte_test() durch: %d", s.st_uid);
#endif
	return (s.st_uid);						// wem gehrts
}









void warten(long msec)
{
	struct timespec a;
	struct timespec b;

	a.tv_nsec = (msec % 1000) * 1000000;
	a.tv_sec = msec / 1000;
	while (nanosleep(&a, &b) != 0)
		a = b;
}
